"""
Django settings for alemhealthhub project.

Generated by 'django-admin startproject' using Django 1.9.7.

For more information on this file, see
https://docs.djangoproject.com/en/1.9/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/1.9/ref/settings/
"""

import os

from utils import load_settings_from_config_file

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))

CACHE_DIR = '/var/cache/alemhealthhub'
LIB_DIR = '/var/lib/alemhealthhub'
OPT_DIR = '/opt/alemhealthhub'

# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/1.9/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = 'hsrhyvrf@8!!^ooz_7&&kf#nqa@2$af8a9@2)u_u^0q%wv9u5@'
# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = True

ALLOWED_HOSTS = []

# sending dicom settings
STORESCU_PARAMS = (
    # '--propose-uncompr',
    # '--propose-little',
    # '--propose-big',
    # '--propose-implicit',
    # '--propose-lossless',
    # '--propose-jpeg8',
    # '--propose-jpeg12',
    # '--propose-j2k-lossless',
    # '--propose-j2k-lossy',
    # '--propose-jls-lossless',
    # '--propose-jls-lossy',
    # '--propose-mpeg2',
    # '--propose-mpeg2-high',
    # '--propose-rle',
    # '-xv',
    # '-xw',
    #        '--log-config %s/dcmtk_log_config.txt' % BASE_DIR,
    # '--debug',
)

CORS_ORIGIN_ALLOW_ALL = True
# Application definition

INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'rest_framework_docs',
    'corsheaders',

    # thrird party
    'djcelery',
    'rest_framework',
    'django_extensions',

    # main apps
    'alemhealthhub',
    'order.apps.OrderConfig',
    'mwl_broker',
    'printing.apps.PrintingConfig',
]

MIDDLEWARE_CLASSES = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    # 'django.middleware.csrf.CsrfViewMiddleware',
    # 'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.auth.middleware.SessionAuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
    'corsheaders.middleware.CorsMiddleware',
    'alemhealthhub.middleware.ProviderSettings'
]

ROOT_URLCONF = 'alemhealthhub.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': ['templates'],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'alemhealthhub.wsgi.application'

# Database
# https://docs.djangoproject.com/en/1.9/ref/settings/#databases

DB_PATH = os.path.join(LIB_DIR, 'data/' 'hub.dat')

DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.sqlite3',
        'NAME': DB_PATH,
    }
}

# Password validation
# https://docs.djangoproject.com/en/1.9/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]

# Internationalization
# https://docs.djangoproject.com/en/1.9/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'UTC'

USE_I18N = True

USE_L10N = True

USE_TZ = True

# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/1.9/howto/static-files/

STATIC_URL = '/static/'
STATIC_ROOT = '/var/www/alemhealthhub/'

# Additional locations of static files
STATICFILES_DIRS = (
    # STATIC_ROOT,
    os.path.join(BASE_DIR, "static"),
    # os.path.join(STATIC_ROOT, 'admin'),
    # Put strings here, like "/home/html/static" or "C:/www/django/static".
    # Always use forward slashes, even on Windows.
    # Don't forget to use absolute paths, not relative paths.
)

STATICFILES_FINDERS = (
    'django.contrib.staticfiles.finders.FileSystemFinder',
    'django.contrib.staticfiles.finders.AppDirectoriesFinder',
    # 'django.contrib.staticfiles.finders.DefaultStorageFinder',
)

# MEDIA_ROOT = os.path.join(BASE_DIR, 'data', 'media')
# MEDIA_ROOT = "/media/alemhealth"

# celery config

BROKER_URL = 'amqp://guest:guest@localhost:5672/'

# celery beat for scheduling
CELERYBEAT_SCHEDULER = 'djcelery.schedulers.DatabaseScheduler'

# all the static vaiables
USE_S3 = False
AWS_STORAGE_BUCKET_NAME = 'alemhealth-local'
AWS_ACCESS_KEY_ID = 'AKIAJIHNP2PTKVCGKBQA'
AWS_SECRET_ACCESS_KEY = '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'

# generate GUID for static

import uuid

STATIC_GUID = uuid.uuid1().hex

# key
CLIENT_SECRET_KEY = 'AH-cfb618dd24b34810ae56b07dc8bb7e2d'

# Middleware API secret key
MIDDLEWARE_SECRET_KEY = 'MI459571ab0b28c4d49935758465665f62'

LOGGING = {
    'version': 1,
    'disable_existing_loggers': False,
    'formatters': {
        'verbose': {
            'format': '[%(asctime)s] %(levelname)s [%(pathname)s:%(lineno)d] %(message)s',
            'datefmt': "%d/%b/%Y %H:%M:%S"
        },
    },
    'handlers': {
        'console': {
            'class': 'logging.StreamHandler',
        },
        'file': {
            'level': 'DEBUG',
            'class': 'logging.handlers.RotatingFileHandler',
            'filename': '/var/log/alemhealthhub/hub.log',
            'mode': 'a',
            'maxBytes': 10 * 1024 * 1024,  # 10 MB LOG FILE SIZE
            'backupCount': 2,
            'encoding': None,
            'delay': 0,
            'formatter': 'verbose'
        },
        'messaging': {
            'level': 'DEBUG',
            'class': 'logging.handlers.RotatingFileHandler',
            'filename': '/var/log/alemhealthhub/messaging.log',
            'mode': 'a',
            'maxBytes': 50 * 1024 * 1024,
            'backupCount': 5,
            'encoding': None,
            'delay': 0,
            'formatter': 'verbose'
        },
        'scripts': {
            'level': 'DEBUG',
            'class': 'logging.handlers.RotatingFileHandler',
            'filename': '/var/log/alemhealthhub/scripts.log',
            'mode': 'a',
            'maxBytes': 50 * 1024 * 1024,  # 10 MB LOG FILE SIZE
            'backupCount': 20,
            'encoding': None,
            'delay': 0,
            'formatter': 'verbose'
        },
    },
    'loggers': {
        'alemhealth': {
            'handlers': ['file'],
            'propagate': True,
            'level': 'DEBUG',
        },
        'alemhealth.scripts': {
            'handlers': ['scripts', 'console'],
            'propagate': False,
            'level': 'DEBUG',
        },
        'django.request': {
            'handlers': ['file'],
            'level': 'DEBUG',
            'propagate': True,
        },
        # 'xhtml2pdf': {
        #     'handlers': ['file'],
        #     'level': 'DEBUG'
        # },
        'alemhealth.messaging': {
            'handlers': ['messaging'],
            'level': 'DEBUG',
            'propagate': False,
        },
    },
}

AH_SERVER = None
MIDDLEWARE_SERVER = None

MEDIA_ROOT = os.path.join(LIB_DIR, 'media')
DICOM_DIR = os.path.join(LIB_DIR, 'dicoms_path')
AH_ENV = "dev"

CONCURRENT_UPLOAD = False

# Box dashboard related settings
NOTIFY_DASHBOARD = False
BOX_DASHBOARD_SERVER = "http://localhost"

BATTERY_HARDWARE_AVAILABLE = True
BATTERY_STATUS_COMMAND = 'upsc AlemHealthUPS@localhost'
# BATTERY_STATUS_COMMAND = 'echo battery.charge: 90'

# Modality work list settings
MODALITY_WORK_LIST = False
WORK_LIST_DB_DIR = os.path.join(LIB_DIR, 'worklist')
WORK_LIST_CACHE_DIR = os.path.join(CACHE_DIR, 'worklist')
WORK_LIST_DEFAULT_AE = "alemmwl"
MIRTH_SERVER_FOR_REPORT = "http://localhost:8282"

RABBITMQ_DASHBOARD = dict(
    EXCHANGE='ah-feed-exchange',
    EXCHANGE_TYPE='direct',
    QUEUE='ah-activity',
    ROUTING_KEY='alemhealth',
    AMQP_URL='amqp://guest:guest@localhost:5672/%2F',
)

ALLOWED_TRANSFER_SYNTAX_DCMCJPLS = [
    '1.2.840.10008.1.2',
    '1.2.840.10008.1.2.1',
    '1.2.840.10008.1.2.1.99',
    '1.2.840.10008.1.2.2',
    'EXPLICIT VR LITTLE ENDIAN',
    'IMPLICIT VR LITTLE ENDIAN',
    'EXPLICIT VR BIG ENDIAN',
    'DEFLATED EXPLICIT VR LITTLE ENDIAN',
]

ENABLE_DCMCJPLS = True

# Load settings from external file
opt_settings = OPT_DIR + '/conf/config.json'
locals().update(load_settings_from_config_file(opt_settings, silent=True) or {})
